# forestvpn_api
ForestVPN defeats content restrictions and censorship to deliver unlimited access to video, music, social media,
and more, from anywhere in the world.


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.0
- Build package: org.openapitools.codegen.languages.DartClientCodegen
For more information, please visit [https://www.forestvpn.com/](https://www.forestvpn.com/)

## Requirements

Dart 2.0 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  forestvpn_api:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  forestvpn_api:
    path: /path/to/forestvpn_api
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:forestvpn_api/api.dart';

// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = AppleApi();
final appStoreReceiptVerificationRequest = AppStoreReceiptVerificationRequest(); // AppStoreReceiptVerificationRequest | 

try {
    api_instance.verifyAppStoreReceipt(appStoreReceiptVerificationRequest);
} catch (e) {
    print('Exception when calling AppleApi->verifyAppStoreReceipt: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *https://api.forestvpn.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AppleApi* | [**verifyAppStoreReceipt**](doc//AppleApi.md#verifyappstorereceipt) | **POST** /purchase/apple/verify/ | App store receipt verification
*AuthApi* | [**migrateLegacyAuth**](doc//AuthApi.md#migratelegacyauth) | **GET** /legacy/auth/ | Legacy auth migration
*AuthApi* | [**whoAmI**](doc//AuthApi.md#whoami) | **GET** /auth/whoami/ | Who am I
*BillingApi* | [**listBillingFeatures**](doc//BillingApi.md#listbillingfeatures) | **GET** /billing/features/ | Billing feature list
*DeviceApi* | [**createDevice**](doc//DeviceApi.md#createdevice) | **POST** /devices/ | Create new device
*DeviceApi* | [**createDevicePortForwarding**](doc//DeviceApi.md#createdeviceportforwarding) | **POST** /devices/{deviceID}/port-forwarding/ | Create new device port forwarding
*DeviceApi* | [**deleteDevice**](doc//DeviceApi.md#deletedevice) | **DELETE** /devices/{deviceID}/ | Delete Device
*DeviceApi* | [**deleteDevicePortForwarding**](doc//DeviceApi.md#deletedeviceportforwarding) | **DELETE** /devices/{deviceID}/port-forwarding/{portForwardingID}/ | Delete Device's Port Forwarding
*DeviceApi* | [**getDevice**](doc//DeviceApi.md#getdevice) | **GET** /devices/{deviceID}/ | Device Info
*DeviceApi* | [**getDeviceStats**](doc//DeviceApi.md#getdevicestats) | **GET** /devices/{deviceID}/stats/{statsID}/ | Device's stats detail
*DeviceApi* | [**getDeviceWireGuard**](doc//DeviceApi.md#getdevicewireguard) | **GET** /devices/{deviceID}/wireguards/{wireGuardID}/ | Device's wireguard profile detail
*DeviceApi* | [**listDeviceBindings**](doc//DeviceApi.md#listdevicebindings) | **GET** /devices/{deviceID}/bindings/ | Device bindings
*DeviceApi* | [**listDeviceConnectionModes**](doc//DeviceApi.md#listdeviceconnectionmodes) | **GET** /devices/{deviceID}/connection-modes/ | Device connection modes
*DeviceApi* | [**listDeviceDetailStats**](doc//DeviceApi.md#listdevicedetailstats) | **GET** /devices/{deviceID}/detail-stats/ | Device's detail stats list
*DeviceApi* | [**listDevicePortForwardings**](doc//DeviceApi.md#listdeviceportforwardings) | **GET** /devices/{deviceID}/port-forwarding/ | Device Port Forwarding List
*DeviceApi* | [**listDeviceStats**](doc//DeviceApi.md#listdevicestats) | **GET** /devices/{deviceID}/stats/ | Device's stats list
*DeviceApi* | [**listDeviceWireGuards**](doc//DeviceApi.md#listdevicewireguards) | **GET** /devices/{deviceID}/wireguards/ | Device's wireguard profiles list
*DeviceApi* | [**listDevices**](doc//DeviceApi.md#listdevices) | **GET** /devices/ | Device List
*DeviceApi* | [**updateDevice**](doc//DeviceApi.md#updatedevice) | **PATCH** /devices/{deviceID}/ | Update device properties
*DeviceApi* | [**updateDevicePortForwarding**](doc//DeviceApi.md#updatedeviceportforwarding) | **PATCH** /devices/{deviceID}/port-forwarding/{portForwardingID}/ | Update device's port forwarding
*FcmApi* | [**createFCMDevice**](doc//FcmApi.md#createfcmdevice) | **POST** /notification/fcm/ | Device registration for push notification through out Firebase Cloud Messaging
*FcmApi* | [**deleteFCMDevice**](doc//FcmApi.md#deletefcmdevice) | **DELETE** /notification/fcm/{registrationID}/ | Delete fcm device
*FcmApi* | [**getFCMDevice**](doc//FcmApi.md#getfcmdevice) | **GET** /notification/fcm/{registrationID}/ | Device info
*FcmApi* | [**updateFCMDevice**](doc//FcmApi.md#updatefcmdevice) | **PATCH** /notification/fcm/{registrationID}/ | Update device fcm properties
*FriendshipApi* | [**acceptFriendshipInvitation**](doc//FriendshipApi.md#acceptfriendshipinvitation) | **PATCH** /friendship/invitations/{code}/ | Accept friendship invitation
*FriendshipApi* | [**createFriendshipInvitation**](doc//FriendshipApi.md#createfriendshipinvitation) | **POST** /friendship/invitations/ | Create friendship invitation
*FriendshipApi* | [**deleteFriend**](doc//FriendshipApi.md#deletefriend) | **DELETE** /friendship/friends/{id}/ | Delete friend
*FriendshipApi* | [**getFriend**](doc//FriendshipApi.md#getfriend) | **GET** /friendship/friends/{id}/ | Friend details
*FriendshipApi* | [**getFriendshipInvitation**](doc//FriendshipApi.md#getfriendshipinvitation) | **GET** /friendship/invitations/{code}/ | Friendship invitation details
*FriendshipApi* | [**listFriends**](doc//FriendshipApi.md#listfriends) | **GET** /friendship/friends/ | Get friends list
*FriendshipApi* | [**rejectFriendshipInvitation**](doc//FriendshipApi.md#rejectfriendshipinvitation) | **DELETE** /friendship/invitations/{code}/ | Reject friendship invitation
*GeoApi* | [**listLocations**](doc//GeoApi.md#listlocations) | **GET** /locations/ | Location list
*GoogleApi* | [**verifyPlayStorePurchase**](doc//GoogleApi.md#verifyplaystorepurchase) | **POST** /purchase/google/verify/ | Play store purchase verification
*WireguardApi* | [**getWireGuardPeerInfo**](doc//WireguardApi.md#getwireguardpeerinfo) | **GET** /wireguard/peers/{pubKey}/ | Wireguard peer info


## Documentation For Models

 - [AppStoreReceiptVerificationRequest](doc//AppStoreReceiptVerificationRequest.md)
 - [BillingFeature](doc//BillingFeature.md)
 - [ConnectionMode](doc//ConnectionMode.md)
 - [Constraint](doc//Constraint.md)
 - [Country](doc//Country.md)
 - [CreateFCMDeviceRequest](doc//CreateFCMDeviceRequest.md)
 - [CreateOrUpdateDeviceRequest](doc//CreateOrUpdateDeviceRequest.md)
 - [CreateOrUpdateDeviceRequestInfo](doc//CreateOrUpdateDeviceRequestInfo.md)
 - [CreateOrUpdatePortForwardingRequest](doc//CreateOrUpdatePortForwardingRequest.md)
 - [Device](doc//Device.md)
 - [DeviceStats](doc//DeviceStats.md)
 - [Environment](doc//Environment.md)
 - [Error](doc//Error.md)
 - [FCMDevice](doc//FCMDevice.md)
 - [Friendship](doc//Friendship.md)
 - [FriendshipInvitation](doc//FriendshipInvitation.md)
 - [LegacyAuthMigrationToken](doc//LegacyAuthMigrationToken.md)
 - [Location](doc//Location.md)
 - [NetworkService](doc//NetworkService.md)
 - [PlayStorePurchaseVerificationRequest](doc//PlayStorePurchaseVerificationRequest.md)
 - [PortForwarding](doc//PortForwarding.md)
 - [Server](doc//Server.md)
 - [UpdateFCMDeviceRequest](doc//UpdateFCMDeviceRequest.md)
 - [User](doc//User.md)
 - [WireGuard](doc//WireGuard.md)
 - [WireGuardPeer](doc//WireGuardPeer.md)
 - [WireGuardPeerDevice](doc//WireGuardPeerDevice.md)
 - [WireGuardPeerInfo](doc//WireGuardPeerInfo.md)
 - [WireGuardPeerUser](doc//WireGuardPeerUser.md)


## Documentation For Authorization


## bearerAuth

- **Type**: HTTP Bearer authentication


## Author

support@forestvpn.com


