# forestvpn_api.api.DeviceApi

## Load the API package
```dart
import 'package:forestvpn_api/api.dart';
```

All URIs are relative to *https://api.forestvpn.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createDevice**](DeviceApi.md#createdevice) | **POST** /devices/ | Create new device
[**createDevicePortForwarding**](DeviceApi.md#createdeviceportforwarding) | **POST** /devices/{deviceID}/port-forwarding/ | Create new device port forwarding
[**deleteDevice**](DeviceApi.md#deletedevice) | **DELETE** /devices/{deviceID}/ | Delete Device
[**deleteDevicePortForwarding**](DeviceApi.md#deletedeviceportforwarding) | **DELETE** /devices/{deviceID}/port-forwarding/{portForwardingID}/ | Delete Device's Port Forwarding
[**getDevice**](DeviceApi.md#getdevice) | **GET** /devices/{deviceID}/ | Device Info
[**getDeviceStats**](DeviceApi.md#getdevicestats) | **GET** /devices/{deviceID}/stats/{statsID}/ | Device's stats detail
[**getDeviceWireGuard**](DeviceApi.md#getdevicewireguard) | **GET** /devices/{deviceID}/wireguards/{wireGuardID}/ | Device's wireguard profile detail
[**listDeviceBindings**](DeviceApi.md#listdevicebindings) | **GET** /devices/{deviceID}/bindings/ | Device bindings
[**listDeviceConnectionModes**](DeviceApi.md#listdeviceconnectionmodes) | **GET** /devices/{deviceID}/connection-modes/ | Device connection modes
[**listDeviceDetailStats**](DeviceApi.md#listdevicedetailstats) | **GET** /devices/{deviceID}/detail-stats/ | Device's detail stats list
[**listDevicePortForwardings**](DeviceApi.md#listdeviceportforwardings) | **GET** /devices/{deviceID}/port-forwarding/ | Device Port Forwarding List
[**listDeviceStats**](DeviceApi.md#listdevicestats) | **GET** /devices/{deviceID}/stats/ | Device's stats list
[**listDeviceWireGuards**](DeviceApi.md#listdevicewireguards) | **GET** /devices/{deviceID}/wireguards/ | Device's wireguard profiles list
[**listDevices**](DeviceApi.md#listdevices) | **GET** /devices/ | Device List
[**updateDevice**](DeviceApi.md#updatedevice) | **PATCH** /devices/{deviceID}/ | Update device properties
[**updateDevicePortForwarding**](DeviceApi.md#updatedeviceportforwarding) | **PATCH** /devices/{deviceID}/port-forwarding/{portForwardingID}/ | Update device's port forwarding


# **createDevice**
> Device createDevice(createOrUpdateDeviceRequest)

Create new device

Create new device 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final createOrUpdateDeviceRequest = CreateOrUpdateDeviceRequest(); // CreateOrUpdateDeviceRequest | 

try { 
    final result = api_instance.createDevice(createOrUpdateDeviceRequest);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->createDevice: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **createOrUpdateDeviceRequest** | [**CreateOrUpdateDeviceRequest**](CreateOrUpdateDeviceRequest.md)|  | [optional] 

### Return type

[**Device**](Device.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **createDevicePortForwarding**
> PortForwarding createDevicePortForwarding(deviceID, createOrUpdatePortForwardingRequest)

Create new device port forwarding

Create new device port forwarding 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final createOrUpdatePortForwardingRequest = CreateOrUpdatePortForwardingRequest(); // CreateOrUpdatePortForwardingRequest | 

try { 
    final result = api_instance.createDevicePortForwarding(deviceID, createOrUpdatePortForwardingRequest);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->createDevicePortForwarding: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **createOrUpdatePortForwardingRequest** | [**CreateOrUpdatePortForwardingRequest**](CreateOrUpdatePortForwardingRequest.md)|  | [optional] 

### Return type

[**PortForwarding**](PortForwarding.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteDevice**
> deleteDevice(deviceID)

Delete Device

Delete device by id 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 

try { 
    api_instance.deleteDevice(deviceID);
} catch (e) {
    print('Exception when calling DeviceApi->deleteDevice: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 

### Return type

void (empty response body)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteDevicePortForwarding**
> deleteDevicePortForwarding(deviceID, portForwardingID)

Delete Device's Port Forwarding

Delete device's port forwarding by id 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final portForwardingID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 

try { 
    api_instance.deleteDevicePortForwarding(deviceID, portForwardingID);
} catch (e) {
    print('Exception when calling DeviceApi->deleteDevicePortForwarding: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **portForwardingID** | [**String**](.md)|  | 

### Return type

void (empty response body)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getDevice**
> Device getDevice(deviceID)

Device Info

Retrieve device info 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 

try { 
    final result = api_instance.getDevice(deviceID);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->getDevice: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 

### Return type

[**Device**](Device.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getDeviceStats**
> DeviceStats getDeviceStats(deviceID, statsID)

Device's stats detail

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final statsID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 

try { 
    final result = api_instance.getDeviceStats(deviceID, statsID);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->getDeviceStats: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **statsID** | [**String**](.md)|  | 

### Return type

[**DeviceStats**](DeviceStats.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getDeviceWireGuard**
> WireGuard getDeviceWireGuard(deviceID, wireGuardID)

Device's wireguard profile detail

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final wireGuardID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 

try { 
    final result = api_instance.getDeviceWireGuard(deviceID, wireGuardID);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->getDeviceWireGuard: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **wireGuardID** | [**String**](.md)|  | 

### Return type

[**WireGuard**](WireGuard.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **listDeviceBindings**
> List<String> listDeviceBindings(deviceID)

Device bindings

Each device has bindings to specific servers. This methods returns hostnames where this device binded in a particular time. 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 

try { 
    final result = api_instance.listDeviceBindings(deviceID);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->listDeviceBindings: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 

### Return type

**List<String>**

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **listDeviceConnectionModes**
> List<ConnectionMode> listDeviceConnectionModes(deviceID, xAndroidPackage, xAndroidSHA1)

Device connection modes

This methods returns list of connection modes are availbale for current device. 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final xAndroidPackage = xAndroidPackage_example; // String | 
final xAndroidSHA1 = xAndroidSHA1_example; // String | 

try { 
    final result = api_instance.listDeviceConnectionModes(deviceID, xAndroidPackage, xAndroidSHA1);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->listDeviceConnectionModes: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **xAndroidPackage** | **String**|  | [optional] 
 **xAndroidSHA1** | **String**|  | [optional] 

### Return type

[**List<ConnectionMode>**](ConnectionMode.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **listDeviceDetailStats**
> List<DeviceStats> listDeviceDetailStats(deviceID, dateTimeAfter, dateTimeBefore, perPage, page)

Device's detail stats list

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final dateTimeAfter = dateTimeAfter_example; // String | 
final dateTimeBefore = dateTimeBefore_example; // String | 
final perPage = 8.14; // num | 
final page = 8.14; // num | 

try { 
    final result = api_instance.listDeviceDetailStats(deviceID, dateTimeAfter, dateTimeBefore, perPage, page);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->listDeviceDetailStats: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **dateTimeAfter** | **String**|  | [optional] 
 **dateTimeBefore** | **String**|  | [optional] 
 **perPage** | **num**|  | [optional] 
 **page** | **num**|  | [optional] 

### Return type

[**List<DeviceStats>**](DeviceStats.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **listDevicePortForwardings**
> List<PortForwarding> listDevicePortForwardings(deviceID, perPage, page)

Device Port Forwarding List

Retrieve device's port forwarding lis 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final perPage = 8.14; // num | 
final page = 8.14; // num | 

try { 
    final result = api_instance.listDevicePortForwardings(deviceID, perPage, page);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->listDevicePortForwardings: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **perPage** | **num**|  | [optional] 
 **page** | **num**|  | [optional] 

### Return type

[**List<PortForwarding>**](PortForwarding.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **listDeviceStats**
> List<DeviceStats> listDeviceStats(deviceID, dateAfter, dateBefore, perPage, page)

Device's stats list

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final dateAfter = 2013-10-20; // DateTime | 
final dateBefore = 2013-10-20; // DateTime | 
final perPage = 8.14; // num | 
final page = 8.14; // num | 

try { 
    final result = api_instance.listDeviceStats(deviceID, dateAfter, dateBefore, perPage, page);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->listDeviceStats: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **dateAfter** | **DateTime**|  | [optional] 
 **dateBefore** | **DateTime**|  | [optional] 
 **perPage** | **num**|  | [optional] 
 **page** | **num**|  | [optional] 

### Return type

[**List<DeviceStats>**](DeviceStats.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **listDeviceWireGuards**
> List<WireGuard> listDeviceWireGuards(deviceID, perPage, page)

Device's wireguard profiles list

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final perPage = 8.14; // num | 
final page = 8.14; // num | 

try { 
    final result = api_instance.listDeviceWireGuards(deviceID, perPage, page);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->listDeviceWireGuards: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **perPage** | **num**|  | [optional] 
 **page** | **num**|  | [optional] 

### Return type

[**List<WireGuard>**](WireGuard.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **listDevices**
> List<Device> listDevices(externalKey, perPage, page)

Device List

Retrieve devices list 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final externalKey = externalKey_example; // String | 
final perPage = 8.14; // num | 
final page = 8.14; // num | 

try { 
    final result = api_instance.listDevices(externalKey, perPage, page);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->listDevices: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **externalKey** | **String**|  | [optional] 
 **perPage** | **num**|  | [optional] 
 **page** | **num**|  | [optional] 

### Return type

[**List<Device>**](Device.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **updateDevice**
> Device updateDevice(deviceID, createOrUpdateDeviceRequest)

Update device properties

Update device properties 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final createOrUpdateDeviceRequest = CreateOrUpdateDeviceRequest(); // CreateOrUpdateDeviceRequest | 

try { 
    final result = api_instance.updateDevice(deviceID, createOrUpdateDeviceRequest);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->updateDevice: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **createOrUpdateDeviceRequest** | [**CreateOrUpdateDeviceRequest**](CreateOrUpdateDeviceRequest.md)|  | 

### Return type

[**Device**](Device.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **updateDevicePortForwarding**
> PortForwarding updateDevicePortForwarding(deviceID, portForwardingID, createOrUpdatePortForwardingRequest)

Update device's port forwarding

Update device's port forwarding dst_port 

### Example 
```dart
import 'package:forestvpn_api/api.dart';
// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DeviceApi();
final deviceID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final portForwardingID = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final createOrUpdatePortForwardingRequest = CreateOrUpdatePortForwardingRequest(); // CreateOrUpdatePortForwardingRequest | 

try { 
    final result = api_instance.updateDevicePortForwarding(deviceID, portForwardingID, createOrUpdatePortForwardingRequest);
    print(result);
} catch (e) {
    print('Exception when calling DeviceApi->updateDevicePortForwarding: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceID** | [**String**](.md)|  | 
 **portForwardingID** | [**String**](.md)|  | 
 **createOrUpdatePortForwardingRequest** | [**CreateOrUpdatePortForwardingRequest**](CreateOrUpdatePortForwardingRequest.md)|  | 

### Return type

[**PortForwarding**](PortForwarding.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

