//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//


// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class DeviceApi {
  DeviceApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Create new device
  ///
  /// Create new device 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [CreateOrUpdateDeviceRequest] createOrUpdateDeviceRequest:
  Future<Response> createDeviceWithHttpInfo({ CreateOrUpdateDeviceRequest? createOrUpdateDeviceRequest }) async {
    // Verify required params are set.

    final path = r'/devices/';

    Object? postBody = createOrUpdateDeviceRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Create new device
  ///
  /// Create new device 
  ///
  /// Parameters:
  ///
  /// * [CreateOrUpdateDeviceRequest] createOrUpdateDeviceRequest:
  Future<Device?> createDevice({ CreateOrUpdateDeviceRequest? createOrUpdateDeviceRequest }) async {
    final response = await createDeviceWithHttpInfo( createOrUpdateDeviceRequest: createOrUpdateDeviceRequest );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Device',) as Device?;
        }
    return Future<Device>.value(null);
  }

  /// Create new device port forwarding
  ///
  /// Create new device port forwarding 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [CreateOrUpdatePortForwardingRequest] createOrUpdatePortForwardingRequest:
  Future<Response> createDevicePortForwardingWithHttpInfo(String deviceID, { CreateOrUpdatePortForwardingRequest? createOrUpdatePortForwardingRequest }) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/port-forwarding/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody = createOrUpdatePortForwardingRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Create new device port forwarding
  ///
  /// Create new device port forwarding 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [CreateOrUpdatePortForwardingRequest] createOrUpdatePortForwardingRequest:
  Future<PortForwarding?> createDevicePortForwarding(String deviceID, { CreateOrUpdatePortForwardingRequest? createOrUpdatePortForwardingRequest }) async {
    final response = await createDevicePortForwardingWithHttpInfo(deviceID,  createOrUpdatePortForwardingRequest: createOrUpdatePortForwardingRequest );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PortForwarding',) as PortForwarding?;
        }
    return Future<PortForwarding>.value(null);
  }

  /// Delete Device
  ///
  /// Delete device by id 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<Response> deleteDeviceWithHttpInfo(String deviceID) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Delete Device
  ///
  /// Delete device by id 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<void> deleteDevice(String deviceID) async {
    final response = await deleteDeviceWithHttpInfo(deviceID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Delete Device's Port Forwarding
  ///
  /// Delete device's port forwarding by id 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] portForwardingID (required):
  Future<Response> deleteDevicePortForwardingWithHttpInfo(String deviceID, String portForwardingID) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }
    if (portForwardingID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: portForwardingID');
    }

    final path = r'/devices/{deviceID}/port-forwarding/{portForwardingID}/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString())
      .replaceAll('{' + 'portForwardingID' + '}', portForwardingID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Delete Device's Port Forwarding
  ///
  /// Delete device's port forwarding by id 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] portForwardingID (required):
  Future<void> deleteDevicePortForwarding(String deviceID, String portForwardingID) async {
    final response = await deleteDevicePortForwardingWithHttpInfo(deviceID, portForwardingID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Device Info
  ///
  /// Retrieve device info 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<Response> getDeviceWithHttpInfo(String deviceID) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device Info
  ///
  /// Retrieve device info 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<Device?> getDevice(String deviceID) async {
    final response = await getDeviceWithHttpInfo(deviceID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Device',) as Device?;
        }
    return Future<Device>.value(null);
  }

  /// Device's stats detail
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] statsID (required):
  Future<Response> getDeviceStatsWithHttpInfo(String deviceID, String statsID) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }
    if (statsID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: statsID');
    }

    final path = r'/devices/{deviceID}/stats/{statsID}/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString())
      .replaceAll('{' + 'statsID' + '}', statsID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device's stats detail
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] statsID (required):
  Future<DeviceStats?> getDeviceStats(String deviceID, String statsID) async {
    final response = await getDeviceStatsWithHttpInfo(deviceID, statsID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'DeviceStats',) as DeviceStats?;
        }
    return Future<DeviceStats>.value(null);
  }

  /// Device's wireguard profile detail
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] wireGuardID (required):
  Future<Response> getDeviceWireGuardWithHttpInfo(String deviceID, String wireGuardID) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }
    if (wireGuardID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: wireGuardID');
    }

    final path = r'/devices/{deviceID}/wireguards/{wireGuardID}/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString())
      .replaceAll('{' + 'wireGuardID' + '}', wireGuardID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device's wireguard profile detail
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] wireGuardID (required):
  Future<WireGuard?> getDeviceWireGuard(String deviceID, String wireGuardID) async {
    final response = await getDeviceWireGuardWithHttpInfo(deviceID, wireGuardID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'WireGuard',) as WireGuard?;
        }
    return Future<WireGuard>.value(null);
  }

  /// Device bindings
  ///
  /// Each device has bindings to specific servers. This methods returns hostnames where this device binded in a particular time. 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<Response> listDeviceBindingsWithHttpInfo(String deviceID) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/bindings/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device bindings
  ///
  /// Each device has bindings to specific servers. This methods returns hostnames where this device binded in a particular time. 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<List<String>> listDeviceBindings(String deviceID) async {
    final response = await listDeviceBindingsWithHttpInfo(deviceID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<String>') as List)
        .cast<String>()
        .toList(growable: false);
    }
    return Future<List<String>>.value(null);
  }

  /// Device connection modes
  ///
  /// This methods returns list of connection modes are availbale for current device. 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] xAndroidPackage:
  ///
  /// * [String] xAndroidSHA1:
  Future<Response> listDeviceConnectionModesWithHttpInfo(String deviceID, { String? xAndroidPackage, String? xAndroidSHA1 }) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/connection-modes/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (xAndroidPackage != null) {
      headerParams[r'X-Android-Package'] = parameterToString(xAndroidPackage);
    }
    if (xAndroidSHA1 != null) {
      headerParams[r'X-Android-SHA1'] = parameterToString(xAndroidSHA1);
    }

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device connection modes
  ///
  /// This methods returns list of connection modes are availbale for current device. 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] xAndroidPackage:
  ///
  /// * [String] xAndroidSHA1:
  Future<List<ConnectionMode>> listDeviceConnectionModes(String deviceID, { String? xAndroidPackage, String? xAndroidSHA1 }) async {
    final response = await listDeviceConnectionModesWithHttpInfo(deviceID,  xAndroidPackage: xAndroidPackage, xAndroidSHA1: xAndroidSHA1 );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<ConnectionMode>') as List)
        .cast<ConnectionMode>()
        .toList(growable: false);
    }
    return Future<List<ConnectionMode>>.value(null);
  }

  /// Device's detail stats list
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] dateTimeAfter:
  ///
  /// * [String] dateTimeBefore:
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<Response> listDeviceDetailStatsWithHttpInfo(String deviceID, { String? dateTimeAfter, String? dateTimeBefore, num? perPage, num? page }) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/detail-stats/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dateTimeAfter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'date_time_after', dateTimeAfter));
    }
    if (dateTimeBefore != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'date_time_before', dateTimeBefore));
    }
    if (perPage != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'per_page', perPage));
    }
    if (page != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'page', page));
    }

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device's detail stats list
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] dateTimeAfter:
  ///
  /// * [String] dateTimeBefore:
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<List<DeviceStats>> listDeviceDetailStats(String deviceID, { String? dateTimeAfter, String? dateTimeBefore, num? perPage, num? page }) async {
    final response = await listDeviceDetailStatsWithHttpInfo(deviceID,  dateTimeAfter: dateTimeAfter, dateTimeBefore: dateTimeBefore, perPage: perPage, page: page );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<DeviceStats>') as List)
        .cast<DeviceStats>()
        .toList(growable: false);
    }
    return Future<List<DeviceStats>>.value(null);
  }

  /// Device Port Forwarding List
  ///
  /// Retrieve device's port forwarding lis 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<Response> listDevicePortForwardingsWithHttpInfo(String deviceID, { num? perPage, num? page }) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/port-forwarding/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (perPage != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'per_page', perPage));
    }
    if (page != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'page', page));
    }

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device Port Forwarding List
  ///
  /// Retrieve device's port forwarding lis 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<List<PortForwarding>> listDevicePortForwardings(String deviceID, { num? perPage, num? page }) async {
    final response = await listDevicePortForwardingsWithHttpInfo(deviceID,  perPage: perPage, page: page );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<PortForwarding>') as List)
        .cast<PortForwarding>()
        .toList(growable: false);
    }
    return Future<List<PortForwarding>>.value(null);
  }

  /// Device's stats list
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [DateTime] dateAfter:
  ///
  /// * [DateTime] dateBefore:
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<Response> listDeviceStatsWithHttpInfo(String deviceID, { DateTime? dateAfter, DateTime? dateBefore, num? perPage, num? page }) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/stats/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dateAfter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'date_after', dateAfter));
    }
    if (dateBefore != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'date_before', dateBefore));
    }
    if (perPage != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'per_page', perPage));
    }
    if (page != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'page', page));
    }

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device's stats list
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [DateTime] dateAfter:
  ///
  /// * [DateTime] dateBefore:
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<List<DeviceStats>> listDeviceStats(String deviceID, { DateTime? dateAfter, DateTime? dateBefore, num? perPage, num? page }) async {
    final response = await listDeviceStatsWithHttpInfo(deviceID,  dateAfter: dateAfter, dateBefore: dateBefore, perPage: perPage, page: page );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<DeviceStats>') as List)
        .cast<DeviceStats>()
        .toList(growable: false);
    }
    return Future<List<DeviceStats>>.value(null);
  }

  /// Device's wireguard profiles list
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<Response> listDeviceWireGuardsWithHttpInfo(String deviceID, { num? perPage, num? page }) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/wireguards/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (perPage != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'per_page', perPage));
    }
    if (page != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'page', page));
    }

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device's wireguard profiles list
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<List<WireGuard>> listDeviceWireGuards(String deviceID, { num? perPage, num? page }) async {
    final response = await listDeviceWireGuardsWithHttpInfo(deviceID,  perPage: perPage, page: page );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<WireGuard>') as List)
        .cast<WireGuard>()
        .toList(growable: false);
    }
    return Future<List<WireGuard>>.value(null);
  }

  /// Device List
  ///
  /// Retrieve devices list 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] externalKey:
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<Response> listDevicesWithHttpInfo({ String? externalKey, num? perPage, num? page }) async {
    // Verify required params are set.

    final path = r'/devices/';

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (externalKey != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'external_key', externalKey));
    }
    if (perPage != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'per_page', perPage));
    }
    if (page != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'page', page));
    }

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device List
  ///
  /// Retrieve devices list 
  ///
  /// Parameters:
  ///
  /// * [String] externalKey:
  ///
  /// * [num] perPage:
  ///
  /// * [num] page:
  Future<List<Device>> listDevices({ String? externalKey, num? perPage, num? page }) async {
    final response = await listDevicesWithHttpInfo( externalKey: externalKey, perPage: perPage, page: page );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<Device>') as List)
        .cast<Device>()
        .toList(growable: false);
    }
    return Future<List<Device>>.value(null);
  }

  /// Update device properties
  ///
  /// Update device properties 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [CreateOrUpdateDeviceRequest] createOrUpdateDeviceRequest (required):
  Future<Response> updateDeviceWithHttpInfo(String deviceID, CreateOrUpdateDeviceRequest createOrUpdateDeviceRequest) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }
    if (createOrUpdateDeviceRequest == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: createOrUpdateDeviceRequest');
    }

    final path = r'/devices/{deviceID}/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object postBody = createOrUpdateDeviceRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Update device properties
  ///
  /// Update device properties 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [CreateOrUpdateDeviceRequest] createOrUpdateDeviceRequest (required):
  Future<Device?> updateDevice(String deviceID, CreateOrUpdateDeviceRequest createOrUpdateDeviceRequest) async {
    final response = await updateDeviceWithHttpInfo(deviceID, createOrUpdateDeviceRequest);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Device',) as Device?;
        }
    return Future<Device>.value(null);
  }

  /// Update device's port forwarding
  ///
  /// Update device's port forwarding dst_port 
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] portForwardingID (required):
  ///
  /// * [CreateOrUpdatePortForwardingRequest] createOrUpdatePortForwardingRequest (required):
  Future<Response> updateDevicePortForwardingWithHttpInfo(String deviceID, String portForwardingID, CreateOrUpdatePortForwardingRequest createOrUpdatePortForwardingRequest) async {
    // Verify required params are set.
    if (deviceID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }
    if (portForwardingID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: portForwardingID');
    }
    if (createOrUpdatePortForwardingRequest == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: createOrUpdatePortForwardingRequest');
    }

    final path = r'/devices/{deviceID}/port-forwarding/{portForwardingID}/'
      .replaceAll('{' + 'deviceID' + '}', deviceID.toString())
      .replaceAll('{' + 'portForwardingID' + '}', portForwardingID.toString());

    Object postBody = createOrUpdatePortForwardingRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Update device's port forwarding
  ///
  /// Update device's port forwarding dst_port 
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [String] portForwardingID (required):
  ///
  /// * [CreateOrUpdatePortForwardingRequest] createOrUpdatePortForwardingRequest (required):
  Future<PortForwarding?> updateDevicePortForwarding(String deviceID, String portForwardingID, CreateOrUpdatePortForwardingRequest createOrUpdatePortForwardingRequest) async {
    final response = await updateDevicePortForwardingWithHttpInfo(deviceID, portForwardingID, createOrUpdatePortForwardingRequest);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PortForwarding',) as PortForwarding?;
        }
    return Future<PortForwarding>.value(null);
  }
}
