//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//


// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class FcmApi {
  FcmApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Device registration for push notification through out Firebase Cloud Messaging
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [CreateFCMDeviceRequest] createFCMDeviceRequest (required):
  Future<Response> createFCMDeviceWithHttpInfo(CreateFCMDeviceRequest createFCMDeviceRequest) async {
    // Verify required params are set.
    if (createFCMDeviceRequest == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: createFCMDeviceRequest');
    }

    final path = r'/notification/fcm/';

    Object postBody = createFCMDeviceRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device registration for push notification through out Firebase Cloud Messaging
  ///
  /// Parameters:
  ///
  /// * [CreateFCMDeviceRequest] createFCMDeviceRequest (required):
  Future<FCMDevice?> createFCMDevice(CreateFCMDeviceRequest createFCMDeviceRequest) async {
    final response = await createFCMDeviceWithHttpInfo(createFCMDeviceRequest);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'FCMDevice',) as FCMDevice?;
        }
    return Future<FCMDevice>.value(null);
  }

  /// Delete fcm device
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] registrationID (required):
  Future<Response> deleteFCMDeviceWithHttpInfo(String registrationID) async {
    // Verify required params are set.
    if (registrationID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: registrationID');
    }

    final path = r'/notification/fcm/{registrationID}/'
      .replaceAll('{' + 'registrationID' + '}', registrationID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Delete fcm device
  ///
  /// Parameters:
  ///
  /// * [String] registrationID (required):
  Future<void> deleteFCMDevice(String registrationID) async {
    final response = await deleteFCMDeviceWithHttpInfo(registrationID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Device info
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] registrationID (required):
  Future<Response> getFCMDeviceWithHttpInfo(String registrationID) async {
    // Verify required params are set.
    if (registrationID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: registrationID');
    }

    final path = r'/notification/fcm/{registrationID}/'
      .replaceAll('{' + 'registrationID' + '}', registrationID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device info
  ///
  /// Parameters:
  ///
  /// * [String] registrationID (required):
  Future<FCMDevice?> getFCMDevice(String registrationID) async {
    final response = await getFCMDeviceWithHttpInfo(registrationID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'FCMDevice',) as FCMDevice?;
        }
    return Future<FCMDevice>.value(null);
  }

  /// Update device fcm properties
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] registrationID (required):
  ///
  /// * [UpdateFCMDeviceRequest] updateFCMDeviceRequest (required):
  Future<Response> updateFCMDeviceWithHttpInfo(String registrationID, UpdateFCMDeviceRequest updateFCMDeviceRequest) async {
    // Verify required params are set.
    if (registrationID == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: registrationID');
    }
    if (updateFCMDeviceRequest == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: updateFCMDeviceRequest');
    }

    final path = r'/notification/fcm/{registrationID}/'
      .replaceAll('{' + 'registrationID' + '}', registrationID.toString());

    Object postBody = updateFCMDeviceRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];


    return await apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Update device fcm properties
  ///
  /// Parameters:
  ///
  /// * [String] registrationID (required):
  ///
  /// * [UpdateFCMDeviceRequest] updateFCMDeviceRequest (required):
  Future<FCMDevice?> updateFCMDevice(String registrationID, UpdateFCMDeviceRequest updateFCMDeviceRequest) async {
    final response = await updateFCMDeviceWithHttpInfo(registrationID, updateFCMDeviceRequest);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'FCMDevice',) as FCMDevice?;
        }
    return Future<FCMDevice>.value(null);
  }
}
